/*  Hive.h
    Hive file access, pretty lame and bugged but do the work O_o
    Thanks to B.D. for file structure info
  
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  
    Nicola Cuomo - ncuomo@studenti.unina.it
*/

#ifndef HIVE_H
#define HIVE_H

#include <stdio.h>
#include <stdlib.h>
#include <Windows.h>

struct hive
{
	unsigned char *base;
};

typedef struct _nk_hdr 
{
	WORD	id;
	WORD	type;
	DWORD	t1, t2;
	DWORD	unk1;
	DWORD	parent_off;
	DWORD	subkey_num;
	DWORD	unk2;
	DWORD	lf_off;
	DWORD	unk3;
	DWORD	value_cnt;
	DWORD	value_off;
	DWORD	sk_off;
	DWORD	classname_off;
	DWORD	unk4[4];
	DWORD	unk5;
	WORD	name_len;
	WORD	classname_len;
	char	key_name[1]; 
} nk_hdr;

typedef struct _hashrecord 
{

	DWORD	nk_offset;
	char	keyname[4];
} hashrecord;

typedef struct _lf_hdr 
{
	WORD	id;
	WORD	key_num;
	hashrecord hr[1];
} lf_hdr;

#define NK_ID	0x6B6E
#define NK_ROOT 0x2c

#define LF_ID	0x666C

#define read_nk( hive, offset ) ( (nk_hdr*) (hive->base + offset + 4)  )
#define read_lf( hive, offset ) ( (lf_hdr*) (hive->base + offset + 4)  )
#define read_vk( hive, offset ) ( (vk_hdr*) (hive->base + offset + 4)  )
#define read_valuelist( hive, offset ) ( (DWORD*) (hive->base + offset + 4)  )
#define read_data( hive, offset ) ( (unsigned char*) ((hive)->base + offset + 4)  )

typedef struct _vk_hdr 
{
	WORD  id;
	WORD  name_len;
	DWORD data_len;
	DWORD data_off;
	DWORD data_type;
	WORD  flag;
	WORD unk1;
	char value_name[1];
} vk_hdr;

void _RegCloseHive( struct hive *h );

void _InitHive( struct hive *h );

int _RegOpenHive( char *filename, struct hive *h );

long parself( struct hive *h, char *t, unsigned long off );

int _RegOpenKey( struct hive *h, char *path, nk_hdr **nr );

int _RegQueryValue( struct hive *h, char *name, nk_hdr *nr, unsigned char **buff, int *len );

int _RegEnumKey( struct hive *h, nk_hdr *nr, unsigned int index, char *name, int *namelen );

#endif
